require_relative 'translate2language'
class ModelDefinition;end

class OCModelDefinition < ModelDefinition

  def property_definition(readonly, args)
    property_str = "@property(nonatomic,readonly,class)#{property_type(args[1])}  #{args[0]}; "
  end

  def property_type(property)
    case property
    when String
      return "NSString *"
    when TrueClass,FalseClass
      return "BOOL"
    when Float
      return "float"
    when Fixnum
      return "int"
    when Bignum
      return "long long"
    else
    end
  end 

  def implementation_body(property)
    case property
    when String
      return "getStringForKey:"
    when TrueClass,FalseClass
      return "getBoolForKey:"
    when Float
      return "getFloatForKey:"
    when Fixnum
      return "getInt32ForKey:"
    when Bignum
      return "getInt64ForKey:"
    else
    end
  end

  def propterty_getterGenerator(args)
    property_value = %Q(@"#{args[0]}")
    default_Value = args[1]
    if String === args[1] 
      default_Value = %Q(@"#{default_Value}")
  end
    getter = "\n+(#{property_type(args[1])})#{args[0]} {
      return [VideoConfigCacheMgr #{implementation_body(args[1])}:#{property_value} defaultValue:#{default_Value}];
}\n"
  end

  def property_instance(args)
    property_value = args[1]
    if String === args[1] 
        property_value = %Q(@"#{property_value}")
    end
    instance = "#{property_type(args[1])} _#{args[0]} = #{property_value};"
  end

    
  def header_template
    template = <<-EOS
#import <Foundation/Foundation.h>
<%- if context.headers_str -%>
<%= context.headers_str %>
<%- end -%>

<%- if context.enums_str -%>
<%= context.enums_str %>
<%- end -%>

@interface <%= context.class_name %> : NSObject
<% context.properties.each do |prop| -%>
<%= property_definition(true, prop) %>
<% end -%>
@end
EOS
  end
    
  def implementation_template
      template = <<-EOS
#import "<%= context.class_name %>.h"
#import "VideoConfigCacheMgr.h"

@implementation <%= context.class_name %>
<% context.properties.each do |prop| -%>
<%= propterty_getterGenerator(prop) %>
<% end -%>
@end
EOS
  end


  def finishTranslate
      replace_file("#{getDirPath}/#{class_name}.h",header)
      replace_file("#{getDirPath}/#{class_name}.m",implementation)
  end
end
