require 'erb'
require_relative 'translate2OC'
require_relative 'translate2java'

# 代码生成器上下文，保存数据
class Context
    @@videoConfigClassName = "className"
    @@videoConfigProperties = "properties"
    attr_reader :properties,
        :class_name,
        :headers_str,
        :enums_str

    def initialize(classname,properties)
        @class_name = classname
        @properties = properties
    end

    def enums(str)
        @enums_str = str
    end

    def headers(str)
        @headers_str = str
    end
end

# 代码生成器
class ModelDefinition
    attr_accessor :configHash
    def self.getModelDefinition(modelType)
        case modelType
        when "oc"
            modelDefinition = OCModelDefinition.new
        when "java"
            modelDefinition = JAVAModelDefinition.new
        end
    end
    def initialize

    end
    # 头文件生成
    def header
        erb_template = ERB.new(header_template, nil, '-')
        erb_template.result(binding)
    end
    # 实现文件生成
    def implementation
        erb_template = ERB.new(implementation_template, nil, '-')
        erb_template.result(binding)
    end
    # 类名
    def class_name
        context.class_name
    end

    attr_reader :context
    # 生成器上下文
    def setcontext(context)
        @context = context
    end
    # 属性模板
    def property_definition(readonly, args)
        
    end
    # 属性访问器模版
    def propterty_getterGenerator(args)

    end

    #属性类型模板
    def property_type(property)

    end

    # 头文件模版
    def header_template
        
    end
    # 实现文件模版
    def implementation_template

    end

    public
    # 开始转换
    def startTranslate(jsonFilePath)
        begin
            jsonData = File.read(jsonFilePath)
            jsonObj = JSON.parse(jsonData)
            @configHash = jsonObj
            processTranslate
        rescue
            puts("配置文件格式出错")
        end
    end
    # 处理转换
    def processTranslate
        @configHash.each do |key,value|
            setcontext(Context.new(key,value))
            finishTranslate
        end


    end
    # 结束转换
    def finishTranslate


    end

end